PROGRAM_NAME='RGB_Spectrum_DualView_XL_Main'
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 01/23/2003 AT: 08:33:13               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 07/15/2003 AT: 10:46:45         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 07/14/2003                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvTP      = 128:1:0             (* AXT-CA10 TOUCH PANEL     *)
dvDEVICE  = 5001:1:0            (* RGB Spectrum DualView XL *)
vdvDEVICE = 33001:1:0           (* VIRTUAL DEVICE           *)
(* SERIAL CABLE FOR THE RGB Spectrum DualView XL IS 10-752. SEE DOCUMENTATION FOR WIRING DETAILS. *)
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

INTEGER nCHAN_BTN[] =            // BUTTON CHANNELS ON TOUCH PANEL
{
    1,    // HUE BUTTON ON MAIN PAGE
    2,    // FREEZE BTN ON MAIN PAGE
    3,    // WINDOW BTN ON MAIN PAGE
    4,    // SHARPNESS BTN ON MAIN PAGE
    5,    // CONTRAST BTN ON MAIN PAGE
    6,    // BRIGHTNESS BTN ON MAIN PAGE
    7,    // PRIORITY BTN ON MAIN PAGE
    8,    // GAMMA BTN ON MAIN PAGE
    9,    // SATURATION BTN ON MAIN PAGE
    10,    // EXIT BTN ON LEVEL POPUP
    
    11,    // INPUT 1 BTN ON MAIN PAGE
    12,    // INPUT 2 BTN ON MAIN PAGE
    13,    // SET MOVE X COORDINATE ON SETTINGS POPUP
    14,    // SET MOVE Y COORDINATE ON SETTINGS POPUP
    15,    // ENABLE/DISABLE PAN/TILT BTN ON WINDOW ADJUST POPUP
    16,    // ENABLE/DISABLE ZOOM BTN ON WINDOW ADJUST POPUP
    17,    // ENABLE/DISABLE POSITIONING BTN ON WINDOW ADJUST POPUP
    18,    // ENABLE/DISABLE SIZING BTN ON WINDOW ADJUST POPUP
    19,    // UP BTN ON WINDOW ADJUST POPUP
    20,    // DOWN BTN ON WINDOW ADJUST POPUP
    
    21,    // LEFT BTN ON WINDOW ADJUST POPUP
    22,    // RIGHT BTN ON WINDOW ADJUST POPUP
    23,    // TEST PATTERN OFF BTN ON MISC POPUP
    24,    // TEST PATTERN BARS BTN ON MISC POPUP
    25,    // TEST PATTERN HORIZONTAL BARS BTN ON MISC POPUP
    26,    // TEST PATTERN GRID BTN ON MISC POPUP
    27,    // SET MOVE SUBMIT BTN - SETTINGS POPUP
    28,    // FULL SCREEN BTN - SETTINGS POPUP
    29,    // OUTPUT FADE FADE TIME BTN - SETTINGS POPUP
    30,    // COMPOSITE 1 BTN ON EDIT SETTINGS POPUP
    
    31,    // COMPOSITE 2 BTN ON EDIT SETTINGS POPUP
    32,    // S-VIDEO BTN ON EDIT SETTINGS POPUP
    33,    // RGB BTN ON EDIT SETTINGS POPUP
    34,    // NORMAL ASPECT BTN ON EDIT SETTINGS POPUP
    35,    // WIDESCREEN 1 BTN ON EDIT SETTINGS POPUP
    36,    // WIDESCREEN 2 BTN ON EDIT SETTINGS POPUP
    37,    // WIDESCREEN 3 BTN ON EDIT SETTINGS POPUP
    38,    // WIDESCREEN 4 BTN ON EDIT SETTINGS POPUP
    39,    // RECALL PRESET BTN ON MISC POPUP
    40,    // SAVE PRESET BTN ON MISC POPUP
    
    41,    // PRESET 1 BTN ON MISC POPUP
    42,    // PRESET 2 BTN ON MISC POPUP
    43,    // PRESET 3 BTN ON MISC POPUP
    44,    // PRESET 4 BTN ON MISC POPUP
    45,    // PRESET 5 BTN ON MISC POPUP
    46,    // PRESET 6 BTN ON MISC POPUP
    47,	// CROP BTN ON SETTINGS POPUP
    48,	// NORMAL BTN ON SETTINGS POPUP
    49,	// STRETCH BTN ON SETTINGS POPUP
    50,	// OUTPUT FADE BTN ON SETTINGS POPUP
    
    51,	// ALL VIDEO OFF BTN - SETTINGS POPUP
    52,	// OVERSCAN BTN - SETTINGS POPUP
    53,	// UNDERSCAN BTN - SETTINGS POPUP
    54,	// BORDER COLOR BTN - COLORS POPUP
    55,	// LABEL BACKGROUND BTN - COLORS POPUP
    56,	// LABEL COLOR BTN - COLORS POPUP
    57,	// RED COLOR FIELD - COLORS POPUP
    58,	// GREEN COLOR FIELD - COLORS POPUP
    59,	// BLUE COLOR FIELD - COLORS POPUP
    60,	// SUBMIT BTN - COLORS POPUP
    61,	// BORDER WIDTH FIELD - COLORS POPUP
    62,	// LABEL TOGGLE BTN - COLORS POPUP
    63	// RESTORE IMAGE DEFAULTS
}

INTEGER nTXT_BTN[] =            //BUTTON TEXT FIELDS ON TOUCH PANEL
{
    1,    // HUE TXT BTN ON MAIN PAGE
    2,    // FORMAT TXT BTN ON EDIT SETTINGS POPUP
    3,    // BAUDRATE TXT BTN ON EDIT SETTINGS POPUP
    4,    // SHARPNESS TXT BTN ON MAIN PAGE
    5,    // CONTRAST TXT BTN ON MAIN PAGE
    6,    // BRIGHTNESS TXT BTN ON MAIN PAGE
    7,    // PRIORITY TXT BTN ON MAIN PAGE
    8,    // GAMMA TXT BTN ON MAIN PAGE
    9,    // SATURATION TXT BTN ON MAIN PAGE
    10,    // LEVEL TXT  BTN ON LEVEL POPUP
    
    11,    // FIRMWARE TXT BTN ON MAIN PAGE
    12,    // KEYPAD TXT BTN ON KEYPAD POPUP
    13,	// SET MOVE X COORDINATE ON SETTINGS POPUP
    14,	// SET MOVE Y COORDINATE ON SETTINGS POPUP
    15,	// OUTPUT FADE FADE TIME - SETTINGS POPUP
    16,	// RED COLOR FIELD - COLORS POPUP
    17,	// GREEN COLOR FIELD - COLORS POPUP
    18,	// BLUE COLOR FIELD - COLORS POPUP
    19	// BORDER WIDTH FIELD - COLORS POPUP
}
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

DEFINE_MODULE 'RGB_Spectrum_DualView_XL_Comm' COMM1(vdvDEVICE, dvDEVICE)
DEFINE_MODULE 'RGB_Spectrum_DualView_XL_UI'   TP1(vdvDEVICE, dvTP, nCHAN_BTN, nTXT_BTN)
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)