MODULE_NAME='RGB_Spectrum_DualView_XL_UI' (DEV vdvDEVICE, DEV dvTP, INTEGER nCHAN_BTN[], INTEGER nTXT_BTN[])
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 01/30/2003 AT: 08:51:36               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 12/03/2003 AT: 11:28:42         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 07/14/2003                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR sVERSION[5]           // STORES NETLINX COMM MODULE VERSION NUMBER
VOLATILE CHAR cKEYPAD_ENTRY[5] = '' // STORES THE PRIORITY NUMBER ENTERED ON THE TP KEYPAD
VOLATILE CHAR cFADE_TIME[2] = ''	 // STORES OUTPUT FADE TIME ENTERED IN KEYPAD
VOLATILE CHAR cVIDEO_FADE[2] = ''	 // STORES VIDEO FADE TIME ENTERED IN KEYPAD
VOLATILE CHAR cSET_MOVE[2][2] = {'',''}	// STORES THE STEP SIZE ENTERED ON THE TP KEYPAD
VOLATILE CHAR cWINDOW_STEP[2][2] = {'', ''}	// STORES THE STEP SIZE RETURNED BY THE DEVICE
VOLATILE CHAR cCOLOR[3][3] = {'','',''}	// STORES THE RGB SETTINGS ENTERED IN KEYPAD
VOLATILE CHAR cBORDER_COLOR[3][3] = {'','',''}	// BORDER COLOR RETURNED BY DEVICE
VOLATILE CHAR cLABEL_BK[3][3] = {'','',''}	// LABEL BACKGROUND COLOR RETURNED BY DEVICE
VOLATILE CHAR cLABEL_COLOR[3][3] = {'','',''}	// LABEL COLOR RETURNED BY DEVICE
VOLATILE CHAR cBORDER_WIDTH[3] = ''	// STORES THE BORDER PIXEL WIDTH ENTERED IN KEYPAD
VOLATILE INTEGER nDEBUG = 0         // TRACKS THE ON/OFF STATE OF DEBUG MSGS SENT TO THE TELNET SESSION
VOLATILE INTEGER nCUR_INPUT = 0     // TRACKS THE CURRENTLY SELECTED INPUT
VOLATILE INTEGER nCUR_TYPE = 0      // TRACKS THE TYPE OF THE CURRENTLY SELECTED INPUT
VOLATILE INTEGER nPRESET = 0        // PRESET TO STORE/RECALL SETTINGS IN/FROM
VOLATILE INTEGER nENABLE_LEVEL = 1  // INDICATES WHEN ITS OK TO ACTIVATE THE TP LEVELS
VOLATILE INTEGER nDEVICE_SCALE = 0  // STORES THE ON/OFF STATE OF DEVICE SCALE
VOLATILE INTEGER nASPECT = 0        // STORES THE CURRENT INPUT'S ASPECT SETTING
VOLATILE INTEGER nFREEZE = 0        // STORES THE CURRENT INPUT'S FREEZE STATE
VOLATILE INTEGER nINPUT_MODE = 0    // STORES THE CURRENT INPUT'S MODE
VOLATILE INTEGER nTEST_PATTERN = 0  // STORES THE CURRENT TEST PATTERN STATE
VOLATILE INTEGER nVIDEO = 0         // STORES THE CURRENT INPUT'S WINDOW STATE
VOLATILE INTEGER nDUALVIEW = 0	 // STORES THE CURRENT DUALVIEW SETTING
VOLATILE INTEGER nFADE = 0		 // STORES THE CURRENT OUTPUT FADE SETTING
VOLATILE INTEGER nVIDEO_FADE = 0	 // STORES THE CURRENT VIDEO FADE SETTING
VOLATILE INTEGER bLABEL = 0		 // STORES THE CURRENT STATE OF THE WINDOW LABELS
VOLATILE SLONG slBRIGHTNESS = 0     // STORES THE CURRENT INPUT'S BRIGHTNESS LEVEL
VOLATILE SLONG slCONTRAST = 0       // STORES THE CURRENT INPUT'S CONTRAST LEVEL
VOLATILE SLONG slSHARPNESS = 0      // STORES THE CURRENT INPUT'S SHARPNESS LEVEL
VOLATILE SLONG slHUE = 0            // STORES THE CURRENT INPUT'S HUE LEVEL
VOLATILE SLONG slCOLOR = 0          // STORES THE CURRENT INPUT'S COLOR LEVEL
VOLATILE FLOAT fGAMMA = 0.0         // STORES THE CURRENT GAMMA LEVEL
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION SLONG Scale_Range(SLONG Num_In, SLONG Min_In, SLONG Max_In, SLONG Min_Out, SLONG Max_Out)
{
    STACK_VAR
    SLONG Val_In
    SLONG Range_In
    SLONG Range_Out
    SLONG Whole_Num
    FLOAT Num_Out
    
    Val_In = Num_In                 // Get input value
    IF(Val_In == Min_In)            // Handle endpoints
        {Num_Out = Min_Out}
    ELSE IF(Val_In == Max_In)
        {Num_Out = Max_Out}
    ELSE                            // Otherwise scale...
    {
        Range_In = Max_In - Min_In      // Establish input range
        Range_Out = Max_Out - Min_Out   // Establish output range
        Val_In = Val_In - Min_In        // Remove input offset
        Num_Out = Val_In * Range_Out    // Multiply by output range
        Num_Out = Num_Out / Range_In    // Then divide by input range
        Num_Out = Num_Out + Min_Out     // Add in minimum output value
        Whole_Num = TYPE_CAST(Num_Out)  // Store the whole number only of the result
        IF (Num_Out >= 0 AND (((Num_Out - Whole_Num)* 100.0) >= 50.0)) { Num_Out++ }    // round up
        ELSE IF (Num_Out < 0 AND (((Num_Out - Whole_Num) * 100.0) <= -50.0)) { Num_Out-- }    // round down
    }
    Return TYPE_CAST(Num_Out)
}
DEFINE_FUNCTION FLOAT fScale_Range(FLOAT Num_In, FLOAT Min_In, FLOAT Max_In, FLOAT Min_Out, FLOAT Max_Out)
{
    STACK_VAR
    FLOAT Val_In
    FLOAT Range_In
    FLOAT Range_Out
    FLOAT Whole_Num
    FLOAT Num_Out
    
    Val_In = Num_In                 // Get input value
    IF(Val_In == Min_In)            // Handle endpoints
        {Num_Out = Min_Out}
    ELSE IF(Val_In == Max_In)
        {Num_Out = Max_Out}
    ELSE                            // Otherwise scale...
    {
        Range_In = Max_In - Min_In      // Establish input range
        Range_Out = Max_Out - Min_Out   // Establish output range
        Val_In = Val_In - Min_In        // Remove input offset
        Num_Out = Val_In * Range_Out    // Multiply by output range
        Num_Out = Num_Out / Range_In    // Then divide by input range
        Num_Out = Num_Out + Min_Out     // Add in minimum output value
        Whole_Num = TYPE_CAST(Num_Out)  // Store the whole number only of the result
        IF (Num_Out >= 0 AND (((Num_Out - Whole_Num)* 100.0) >= 50.0)) { Num_Out++ }    // round up
        ELSE IF (Num_Out < 0 AND (((Num_Out - Whole_Num) * 100.0) <= -50.0)) { Num_Out-- }    // round down
    }
    Return TYPE_CAST(Num_Out)
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

WAIT 70    // GIVE THE COMM MODULE ONLINE EVENT TIME TO EXECUTE
{
    SEND_COMMAND vdvDEVICE, "'FIRMWARE?'"
    SEND_COMMAND vdvDEVICE, "'GAMMA?'"
    SEND_COMMAND vdvDEVICE, "'SET_MOVE?'"
    SEND_COMMAND vdvDEVICE, "'DUALVIEW?'"
    SEND_COMMAND vdvDEVICE, "'OUTPUT_FADE?'"
}
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[vdvDEVICE]
{
    STRING:
    {
        STACK_VAR CHAR cCMD[35]
        
        IF(nDEBUG) { SEND_STRING 0, "'UI RECEIVED FROM COMM: ',DATA.TEXT" }
        IF(FIND_STRING(DATA.TEXT, '=', 1)) { cCMD = REMOVE_STRING(DATA.TEXT, '=', 1) }        
        ELSE { cCMD = DATA.TEXT }
        SWITCH(cCMD)
        {
            CASE 'ASPECT=':
            {
                STACK_VAR INTEGER nSTATE, nINPUT, N
                
                nSTATE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT) { nASPECT = nSTATE }
            }
            CASE 'BAUD=': { SEND_COMMAND dvTP, "'@TXT',3,DATA.TEXT" } 
		  CASE 'BORDER_COLOR=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cBORDER_COLOR[1] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cBORDER_COLOR[2] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cBORDER_COLOR[3] = DATA.TEXT
				IF ([dvTP, nCHAN_BTN[54]])
				{
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cBORDER_COLOR[1]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cBORDER_COLOR[2]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cBORDER_COLOR[3]"
				}
			 }
		  }
		  CASE 'BORDER_WIDTH=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cBORDER_WIDTH = DATA.TEXT
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[19], cBORDER_WIDTH"	// BORDER PIXEL WIDTH
			 }
		  }
            CASE 'BRIGHTNESS=':
            {
                STACK_VAR INTEGER nINPUT
                
                slBRIGHTNESS = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',6,ITOA(slBRIGHTNESS),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',6,ITOA(slBRIGHTNESS)" }
                }
                IF ([dvTP, 6] AND nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS),'%'"
                        SEND_LEVEL dvTP,1,slBRIGHTNESS*255/100
                    }
                    ELSE
                    {
                        STACK_VAR SLONG slVALUE
                        
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slBRIGHTNESS)"
                        slVALUE = slBRIGHTNESS
                        slVALUE = Scale_Range(slVALUE, -500, 500, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'CONTRAST=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slCONTRAST = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',5,ITOA(slCONTRAST),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',5,ITOA(slCONTRAST)" }
                }
                IF ([dvTP, 5] AND nCUR_INPUT )
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST),'%'"
                        SEND_LEVEL dvTP,1,slCONTRAST*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slCONTRAST)"
                        slVALUE = slCONTRAST
                        slVALUE = Scale_Range(slVALUE, 0, 199, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'DEBUG=': { nDEBUG = ATOI(DATA.TEXT) }
            CASE 'DEVICE_SCALE=':
            {
                IF (nDEVICE_SCALE <> ATOI(DATA.TEXT))
                {
                    nDEVICE_SCALE = ATOI(DATA.TEXT)
                    IF (nCUR_INPUT > 0)
                    {
                        SEND_COMMAND vdvDEVICE, "'GAMMA?'"
                        SEND_COMMAND vdvDEVICE, "'HUE?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEVICE, "'COLOR?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEVICE, "'SHARPNESS?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEVICE, "'CONTRAST?',ITOA(nCUR_INPUT)"
                        SEND_COMMAND vdvDEVICE, "'BRIGHTNESS?',ITOA(nCUR_INPUT)"
                    }
                }
            }
		  CASE 'DUALVIEW=': { nDUALVIEW = ATOI(DATA.TEXT) }
            CASE 'ERRORM=':
            {
                IF (nDEBUG) { SEND_STRING 0, "'ERROR - ',DATA.TEXT" }
            }
            CASE 'FIRMWARE=': { SEND_COMMAND dvTP, "'@TXT',11,DATA.TEXT" }
            CASE 'FREEZE=':
            {
                STACK_VAR INTEGER nSTATE, nINPUT
                
                nSTATE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT) { nFREEZE = nSTATE }
            }
            CASE 'GAMMA=':
            {
                fGAMMA = ATOF(DATA.TEXT)
                IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',8,FORMAT('%1.0f',fGAMMA),'%'" }
                ELSE { SEND_COMMAND dvTP, "'@TXT',8,FORMAT('%1.2f',fGAMMA)" }
                IF ([dvTP, 8])
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,FORMAT('%1.0f',fGAMMA),'%'"
                        SEND_LEVEL dvTP,1,TYPE_CAST(fGAMMA)*255/100
                    }
                    ELSE
                    {
                        STACK_VAR FLOAT fVALUE
                        
                        SEND_COMMAND dvTP, "'@TXT',10,FORMAT('%1.2f',fGAMMA)"
                        fVALUE = fGAMMA
                        fVALUE = fScale_Range(fVALUE, 0.5, 2.0, 0, 100)
                        IF (fVALUE <> -999) { SEND_LEVEL dvTP,1,TYPE_CAST(fVALUE)*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'HUE=':
            {
                STACK_VAR INTEGER nINPUT
                
                slHUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nCUR_INPUT == nINPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',1,ITOA(slHUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',1,ITOA(slHUE)" }
                }
                IF ([dvTP, 1] AND nCUR_INPUT == nINPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slHUE),'%'"
                        SEND_LEVEL dvTP,1,slHUE*255/100
                    }
                    ELSE
                    {
                        STACK_VAR SLONG slVALUE

                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slHUE)"
                        slVALUE = slHUE
                        slVALUE = Scale_Range(slVALUE, -180, 180, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'INPUT=':
            {
                STACK_VAR INTEGER nINPUT, nTYPE
                
                nTYPE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT) { nCUR_TYPE = nTYPE }
            }
		  CASE 'LABEL_BGCOLOR=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_BK[1] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_BK[2] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_BK[3] = DATA.TEXT
				IF ([dvTP, nCHAN_BTN[55]])
				{
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cLABEL_BK[1]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cLABEL_BK[2]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cLABEL_BK[3]"
				}
			 }
		  }
		  CASE 'LABEL_COLOR=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_COLOR[1] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_COLOR[2] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
				REMOVE_STRING(DATA.TEXT, ':', 1)
				cLABEL_COLOR[3] = DATA.TEXT				
				IF ([dvTP, nCHAN_BTN[56]])
				{
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cLABEL_COLOR[1]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cLABEL_COLOR[2]"
				    SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cLABEL_COLOR[3]"
				}
			 }
		  }
		  CASE 'LABEL_ENABLE=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				bLABEL = ATOI(DATA.TEXT)
			 }
		  }
		  CASE 'OUTPUT_FADE=': { nFADE = ATOI(DATA.TEXT) }
		  CASE 'OVER_SCAN=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				IF (DATA.TEXT == 'OFF') { OFF[dvTP, nCHAN_BTN[52]] }
				ELSE IF (DATA.TEXT == 'ON') { ON[dvTP, nCHAN_BTN[52]] }
			 }
		  }
            CASE 'PRIORITY=':
            {
                STACK_VAR INTEGER nINPUT
                
                IF (!FIND_STRING(DATA.TEXT, 'ALL', 1))
                {
                    nINPUT = ATOI(DATA.TEXT)
                    REMOVE_STRING(DATA.TEXT, ':', 1)
                    IF (nINPUT == nCUR_INPUT) { SEND_COMMAND dvTP, "'@TXT', 7, DATA.TEXT" }
                }
                ELSE
                {
                    STACK_VAR INTEGER N
                    
                    REMOVE_STRING(DATA.TEXT, 'ALL:', 1)
                    FOR(N = 1; N < nCUR_INPUT; N++) { REMOVE_STRING(DATA.TEXT, ':', 1) }
                    nINPUT = ATOI(DATA.TEXT)
                    SEND_COMMAND dvTP, "'@TXT', 7, ITOA(nINPUT)"
                }
                
            }
            CASE 'RECALL=':
            {
                STACK_VAR INTEGER nPRESET
                
                nPRESET = ATOI(DATA.TEXT)
            }
            CASE 'COLOR=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slVALUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',9,ITOA(slVALUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',9,ITOA(slVALUE)" }
                    slCOLOR = slVALUE
                }
                IF ([dvTP, 9] AND nCUR_INPUT )
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE),'%'"
                        SEND_LEVEL dvTP,1,slVALUE*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE)"
                        slVALUE = Scale_Range(slVALUE, 0, 199, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'SAVE=':
            {
                STACK_VAR INTEGER nPRESET
                
                nPRESET = ATOI(DATA.TEXT)
            }
		  CASE 'SET_MOVE=':
		  {
			 cWINDOW_STEP[1] = LEFT_STRING(DATA.TEXT, FIND_STRING(DATA.TEXT, ':', 1) - 1)
			 SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[13], cWINDOW_STEP[1]"
			 REMOVE_STRING(DATA.TEXT, ':', 1)
			 cWINDOW_STEP[2] = DATA.TEXT
			 SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[14], cWINDOW_STEP[2]"			 
		  }
            CASE 'SHARPNESS=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR SLONG slVALUE
                
                slVALUE = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE) { SEND_COMMAND dvTP, "'@TXT',4,ITOA(slVALUE),'%'" }
                    ELSE { SEND_COMMAND dvTP, "'@TXT',4,ITOA(slVALUE)" }
                    slSHARPNESS = slVALUE
                }
                IF ([dvTP, 4] AND nINPUT == nCUR_INPUT)
                {
                    IF (!nDEVICE_SCALE)
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE),'%'"
                        SEND_LEVEL dvTP,1,slVALUE*255/100
                    }
                    ELSE
                    {
                        SEND_COMMAND dvTP, "'@TXT',10,ITOA(slVALUE)"
                        slVALUE = Scale_Range(slVALUE, 0, 3, 0, 100)
                        IF (slVALUE <> -999) { SEND_LEVEL dvTP,1,slVALUE*255/100 }
                    }
                    nENABLE_LEVEL=0
                    CANCEL_WAIT 'ENABLE LEVELS'
                    WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
                }
            }
            CASE 'TEST_PATTERN=': { nTEST_PATTERN = ATOI(DATA.TEXT) }
		  CASE 'UNDER_SCAN=':
		  {
			 IF (ATOI(DATA.TEXT) == nCUR_INPUT)
			 {
				REMOVE_STRING(DATA.TEXT, ':', 1)
				IF (DATA.TEXT == 'OFF') { OFF[dvTP, nCHAN_BTN[53]] }
				ELSE IF (DATA.TEXT == 'ON') { ON[dvTP, nCHAN_BTN[53]] }
			 }
		  }
            CASE 'VERSION=': { sVERSION = DATA.TEXT }
            CASE 'VIDEO=':
            {
                STACK_VAR INTEGER nINPUT
                
                nINPUT = ATOI(DATA.TEXT)
                REMOVE_STRING(DATA.TEXT, ':', 1)
                IF (nINPUT == nCUR_INPUT) { nVIDEO = ATOI(DATA.TEXT) }
            }
            CASE 'VIDEOMODE=':
            {
                STACK_VAR INTEGER nINPUT
                STACK_VAR CHAR cVAL[15]
                
                cVAL = REMOVE_STRING(DATA.TEXT, ':', 1)
                SET_LENGTH_STRING(cVAL, LENGTH_STRING(cVAL) - 1)    // REMOVE ':'
                nINPUT = ATOI(DATA.TEXT)
                IF (nINPUT == nCUR_INPUT) { SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[2], cVAL" }
            }
        }// END SWITCH(cCMD)
    }// END STRING
}// END DATA_EVENT[vdvDEVICE]

DATA_EVENT[dvTP]
{
    ONLINE: 
    {
        SEND_COMMAND dvTP, "'@PPX'"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[1],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[2],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[3],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[4],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[5],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[6],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[7],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[8],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[9],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[11],''"
        SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[12],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[13],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[14],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[15],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[16],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[17],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[18],''"
	   SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[19],''"
    }
    STRING:
    {
	   IF (nDEBUG) { SEND_STRING 0, "'UI RECVD FROM TP: ',DATA.TEXT" }
        IF (FIND_STRING(DATA.TEXT, 'TP-', 1))
        {
            REMOVE_STRING(DATA.TEXT, 'TP-', 1)
            IF (DATA.TEXT == 'SAVE') { SEND_COMMAND vdvDEVICE, "'GLOBAL_SAVE'" }
        }
        ELSE IF (FIND_STRING(DATA.TEXT, 'KP-', 1))
        {
            REMOVE_STRING(DATA.TEXT, 'KP-', 1)
            SWITCH(DATA.TEXT)
            {
                CASE 'C':
			 {
				SELECT
				{
				    ACTIVE([dvTP, nCHAN_BTN[7]]): { cKEYPAD_ENTRY = '' }
				    ACTIVE([dvTP, nCHAN_BTN[13]]): { cSET_MOVE[1] = '' }
				    ACTIVE([dvTP, nCHAN_BTN[14]]): { cSET_MOVE[2] = '' }
				    ACTIVE([dvTP, nCHAN_BTN[29]]): { cFADE_TIME = '' }
				    ACTIVE([dvTP, nCHAN_BTN[57]]):
				    {
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[58]]):
				    {
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[59]]):
				    {
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[61]]): { cBORDER_WIDTH = '' }
				}
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], ''"
			 }
                CASE 'E':
                {
				SELECT
				{
				    ACTIVE([dvTP, nCHAN_BTN[7]]):
				    {
					   OFF[dvTP, nCHAN_BTN[7]]
					   cKEYPAD_ENTRY = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[13]]):
				    {
					   OFF[dvTP, nCHAN_BTN[13]]
					   cSET_MOVE[1] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[14]]):
				    {
					   OFF[dvTP, nCHAN_BTN[14]]
					   cSET_MOVE[2] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[29]]):
				    {
					   OFF[dvTP, nCHAN_BTN[29]]
					   cFADE_TIME = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[57]]):
				    {
					   OFF[dvTP, nCHAN_BTN[57]]
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[58]]):
				    {
					   OFF[dvTP, nCHAN_BTN[58]]
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[59]]):
				    {
					   OFF[dvTP, nCHAN_BTN[59]]
					   cCOLOR[1] = ''
					   cCOLOR[2] = ''
					   cCOLOR[3] = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[61]]):
				    {
					   OFF[dvTP, nCHAN_BTN[61]]
					   cBORDER_WIDTH = ''
				    }
				}
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], ''"
                }
                CASE 'G':
                {
				SELECT
				{
				    ACTIVE([dvTP, nCHAN_BTN[7]]):
				    {
					   OFF[dvTP, nCHAN_BTN[7]]
					   SEND_COMMAND vdvDEVICE, "'PRIORITY=',ITOA(nCUR_INPUT),':',cKEYPAD_ENTRY"
					   cKEYPAD_ENTRY = ''
				    }
				    ACTIVE([dvTP, nCHAN_BTN[13]]):
				    {
					   OFF[dvTP, nCHAN_BTN[13]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[13], cSET_MOVE[1]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[14]]):
				    {
					   OFF[dvTP, nCHAN_BTN[14]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[14], cSET_MOVE[2]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[29]]):
				    {
					   OFF[dvTP, nCHAN_BTN[29]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[15], cFADE_TIME"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[57]]):
				    {
					   OFF[dvTP, nCHAN_BTN[57]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cCOLOR[1]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[58]]):
				    {
					   OFF[dvTP, nCHAN_BTN[58]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cCOLOR[2]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[59]]):
				    {
					   OFF[dvTP, nCHAN_BTN[59]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cCOLOR[3]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[61]]):
				    {
					   OFF[dvTP, nCHAN_BTN[61]]
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[19], cBORDER_WIDTH"
					   SEND_COMMAND vdvDEVICE, "'BORDER_WIDTH=',ITOA(nCUR_INPUT),':',cBORDER_WIDTH"
				    }
				}
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], ''"
                }
                DEFAULT :
			 {
				SELECT
				{
				    ACTIVE([dvTP, nCHAN_BTN[7]]):
				    {
					   cKEYPAD_ENTRY = "cKEYPAD_ENTRY,DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cKEYPAD_ENTRY"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[13]]):
				    {
					   cSET_MOVE[1] = "cSET_MOVE[1], DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cSET_MOVE[1]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[14]]):
				    {
					   cSET_MOVE[2] = "cSET_MOVE[2], DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cSET_MOVE[2]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[15]]):
				    {
					   cFADE_TIME = "cFADE_TIME, DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cFADE_TIME"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[57]]):
				    {
					   cCOLOR[1] = "cCOLOR[1], DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cCOLOR[1]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[58]]):
				    {
					   cCOLOR[2] = "cCOLOR[2], DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cCOLOR[2]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[59]]):
				    {
					   cCOLOR[3] = "cCOLOR[3], DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cCOLOR[3]"
				    }
				    ACTIVE([dvTP, nCHAN_BTN[61]]):
				    {
					   cBORDER_WIDTH = "cBORDER_WIDTH, DATA.TEXT"
					   SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[12], cBORDER_WIDTH"
				    }
				}// END SELECT
			 }// END DEFAULT
            }// END SWITCH
        }// END ELSE IF (FIND_STRING(DATA.TEXT, 'KP-', 1))
    }// END STRING
}// END DATA_EVENT[dvTP]

LEVEL_EVENT[dvTP, 1]
{
    IF (nENABLE_LEVEL)
    {
        CANCEL_WAIT 'SEND NEW LEVEL'
        WAIT 2 'SEND NEW LEVEL'
        {
            SELECT
            {
                ACTIVE([dvTP, 1]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'HUE=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, -180, 180)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEVICE,"'HUE=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
                ACTIVE([dvTP, 4]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'SHARPNESS=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, 0, 3)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEVICE,"'SHARPNESS=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                    }
                }
                ACTIVE([dvTP, 5]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'CONTRAST=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)" }
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, 0, 199)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEVICE, "'CONTRAST=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                    }
                }
                ACTIVE([dvTP, 6]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'BRIGHTNESS=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, -500, 500)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEVICE,"'BRIGHTNESS=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
                ACTIVE([dvTP, 8]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'GAMMA=',ITOA(LEVEL.VALUE*100/255)"}
                    ELSE
                    {
                        LOCAL_VAR FLOAT fVAL
                        
                        fVAL = fScale_Range(LEVEL.VALUE*100/255, 0, 100, 0.5, 2.0)
                        IF (fVAL <> -999) { SEND_COMMAND vdvDEVICE,"'GAMMA=',FORMAT('%1.2f',fVAL)" }
                        
                    }
                }
                ACTIVE([dvTP, 9]):
                {
                    IF(!nDEVICE_SCALE){SEND_COMMAND vdvDEVICE,"'COLOR=',ITOA(LEVEL.VALUE*100/255),':',ITOA(nCUR_INPUT)"}
                    ELSE
                    {
                        LOCAL_VAR SLONG slVAL
                        
                        slVAL = Scale_Range(LEVEL.VALUE*100/255, 0, 100, 0, 199)
                        IF (slVAL <> -999) { SEND_COMMAND vdvDEVICE,"'COLOR=',ITOA(slVAL),':',ITOA(nCUR_INPUT)" }
                        
                    }
                }
            }
        }
    }
}

BUTTON_EVENT[dvTP, nCHAN_BTN]
{
    PUSH:
    {
        STACK_VAR INTEGER nBTN
        
        nBTN = GET_LAST(nCHAN_BTN)
        SWITCH(nBTN)
        {
            CASE 1:    // HUE BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF(!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10], ITOA(slHUE),'%'"
                    SEND_LEVEL dvTP,1,slHUE*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slHUE)"
                    slVAL = slHUE
                    slVAL = Scale_Range(slVAL, -180, 180, 0, 100)
                    SEND_LEVEL dvTP, 1, slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 2:    // FREEZE BUTTON
            {
                IF ([dvTP, nCHAN_BTN[2]]) { SEND_COMMAND vdvDEVICE, "'FREEZE=0:',ITOA(nCUR_INPUT)" }
                ELSE { SEND_COMMAND vdvDEVICE, "'FREEZE=1:',ITOA(nCUR_INPUT)" }
                PULSE[dvTP, nCHAN_BTN[2]]
            }
            CASE 3:    // WINDOW BUTTON
            {
                IF ([dvTP, nCHAN_BTN[3]]) { SEND_COMMAND vdvDEVICE, "'VIDEO=',ITOA(nCUR_INPUT),':0'" }
                ELSE { SEND_COMMAND vdvDEVICE, "'VIDEO=',ITOA(nCUR_INPUT),':1'" }
                PULSE[dvTP, nCHAN_BTN[3]]
            }
            CASE 4:    // SHARPNESS BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slSHARPNESS),'%'"
                    SEND_LEVEL dvTP,1,slSHARPNESS*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slSHARPNESS)"
                    slVAL = slSHARPNESS
                    slVAL = Scale_Range(slVAL, 0, 3, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 5:    // CONTRAST BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slCONTRAST),'%'"
                    SEND_LEVEL dvTP,1,slCONTRAST*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slCONTRAST)"
                    slVAL = slCONTRAST
                    slVAL = Scale_Range(slVAL, 0, 199, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 6:    // BRIGHTNESS BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF (!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slBRIGHTNESS),'%'"
                    SEND_LEVEL dvTP,1,slBRIGHTNESS*255/100
                }
                ELSE 
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slBRIGHTNESS)"
                    slVAL = slBRIGHTNESS
                    slVAL = Scale_Range(slVAL, -500, 500, 0, 100)
                    SEND_LEVEL dvTP,1,slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 7:    // PRIORITY BUTTON
            {
                ON[BUTTON.INPUT]
                cKEYPAD_ENTRY = ''
            }
            CASE 8:    // GAMMA BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF(!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10], FORMAT('%1.0f',fGAMMA),'%'"
                    SEND_LEVEL dvTP,1,TYPE_CAST(fGAMMA)*255/100
                }
                ELSE
                {
                    STACK_VAR FLOAT fVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],FORMAT('%1.2f',fGAMMA)"
                    fVAL = fGAMMA
                    fVAL = fScale_Range(fVAL, 0.5, 2.0, 0, 100)
                    SEND_LEVEL dvTP, 1, TYPE_CAST(fVAL)*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 9:    // COLOR BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
                ON[BUTTON.INPUT]
                IF(!nDEVICE_SCALE)
                {
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10], ITOA(slCOLOR),'%'"
                    SEND_LEVEL dvTP,1,slCOLOR*255/100
                }
                ELSE
                {
                    STACK_VAR SLONG slVAL
                    
                    SEND_COMMAND dvTP, "'@TXT',nTXT_BTN[10],ITOA(slCOLOR)"
                    slVAL = slCOLOR
                    slVAL = Scale_Range(slVAL, 0, 199, 0, 100)
                    SEND_LEVEL dvTP, 1, slVAL*255/100
                }
                nENABLE_LEVEL=0
                CANCEL_WAIT 'ENABLE LEVELS'
                WAIT 3 'ENABLE LEVELS' { nENABLE_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            CASE 10:    // LEVEL EXIT BUTTON
            {
                OFF[dvTP, nCHAN_BTN[1]]    // HUE BTN
                OFF[dvTP, nCHAN_BTN[4]]    // SHARPNESS BTN
                OFF[dvTP, nCHAN_BTN[5]]    // CONTRAST BTN
                OFF[dvTP, nCHAN_BTN[6]]    // BRIGHTNESS BTN
                OFF[dvTP, nCHAN_BTN[8]]    // GAMMA BTN
                OFF[dvTP, nCHAN_BTN[9]]    // COLOR BTN
            }
            CASE 11:    // INPUT 1 BUTTON
            CASE 12:    // INPUT 2 BUTTON
            {
                OFF[dvTP, nCHAN_BTN[11]]
                OFF[dvTP, nCHAN_BTN[12]]
                ON[BUTTON.INPUT]
                nCUR_INPUT = nBTN - 10
                SEND_COMMAND vdvDEVICE, "'INPUT?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'PRIORITY?'"
                SEND_COMMAND vdvDEVICE, "'FREEZE?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'VIDEO?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'BRIGHTNESS?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'CONTRAST?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'SHARPNESS?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'INPUT_MODE?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'COLOR?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'HUE?',ITOA(nCUR_INPUT)"
                SEND_COMMAND vdvDEVICE, "'VIDEOMODE?',ITOA(nCUR_INPUT)"   // IF NO INPUT SIGNAL IS PRESENT, THIS WILL RETURN ERROR
			 IF (nCUR_TYPE == 2 OR nCUR_TYPE == 4 OR nCUR_TYPE == 6)
			 {
				SEND_COMMAND vdvDEVICE, "'ASPECT?',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'OVER_SCAN?',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'UNDER_SCAN?',ITOA(nCUR_INPUT)"
			 }			 
			 SEND_COMMAND vdvDEVICE, "'BORDER_COLOR?',ITOA(nCUR_INPUT)"
			 SEND_COMMAND vdvDEVICE, "'LABEL_COLOR?',ITOA(nCUR_INPUT)"
			 SEND_COMMAND vdvDEVICE, "'LABEL_BGCOLOR?',ITOA(nCUR_INPUT)"
			 SEND_COMMAND vdvDEVICE, "'BORDER_WIDTH?',ITOA(nCUR_INPUT)"
			 SEND_COMMAND vdvDEVICE, "'LABEL_ENABLE?',ITOA(nCUR_INPUT)"
            }
		  CASE 13:	// X COORDINATE
		  CASE 14:	// Y COORDINATE
		  {
			 ON[BUTTON.INPUT]
			 cSET_MOVE[nBTN - 12] = ''
		  }
            CASE 15:    // ENABLE/DISABLE PAN/TILT
            CASE 16:    // ENABLE/DISABLE ZOOM
            CASE 17:    // ENABLE/DISABLE POSITIONING
            CASE 18:    // ENABLE/DISABLE SIZING
            {
                IF ([BUTTON.INPUT]) { OFF[BUTTON.INPUT] }
                ELSE
                {
                    OFF[dvTP, nCHAN_BTN[15]]
                    OFF[dvTP, nCHAN_BTN[16]]
                    OFF[dvTP, nCHAN_BTN[17]]
                    OFF[dvTP, nCHAN_BTN[18]]
                    ON[BUTTON.INPUT]
                }
            }
            CASE 19:    // UP BUTTON
            CASE 20:    // DOWN BUTTON
            CASE 21:    // LEFT BUTTON
            CASE 22:    // RIGHT BUTTON
            {
                TO[BUTTON.INPUT]
                SELECT
                {
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':5'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':1'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':7'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':<'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':3'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':>'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':+'" }
                }// END SELECT
            }
            CASE 23:    // TEST PATTERN OFF
            CASE 24:    // TEST PATTERN BARS
            CASE 25:    // TEST PATTERN HORIZONTAL BARS
            CASE 26:    // TEST PATTERN GRID
            {
                PULSE[BUTTON.INPUT]
                SEND_COMMAND vdvDEVICE, "'TEST_PATTERN=',ITOA(nBTN-23)"
            }
		  CASE 27:	// SET MOVE SUBMIT BUTTON
		  {
			 IF (cSET_MOVE[1] == '') { cSET_MOVE[1] = cWINDOW_STEP[1] }
			 IF (cSET_MOVE[2] == '') { cSET_MOVE[2] = cWINDOW_STEP[2] }
			 SEND_COMMAND vdvDEVICE, "'SET_MOVE=',cSET_MOVE[1],':',cSET_MOVE[2]"
			 cSET_MOVE[1] = ''
			 cSET_MOVE[2] = ''
		  }
		  CASE 28: { SEND_COMMAND vdvDEVICE, "'FULL_SCREEN=',ITOA(nCUR_INPUT)" }	// FULL SCREEN BTN
		  CASE 29:
		  {
			 ON[BUTTON.INPUT]
			 cFADE_TIME = ''
			 SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[15], cFADE_TIME"
		  }
            CASE 30:    // COMPOSITE 1 BUTTON
            CASE 31:    // COMPOSITE 2 BUTTON
            CASE 32:    // S-VIDEO BUTTON
            CASE 33:    // RGB BUTTON
            {
                PULSE[BUTTON.INPUT]
                SWITCH(nBTN)
                {
                    CASE 30: { SEND_COMMAND vdvDEVICE, "'INPUT=4:',ITOA(nCUR_INPUT)" }
                    CASE 31: { SEND_COMMAND vdvDEVICE, "'INPUT=6:',ITOA(nCUR_INPUT)" }
                    CASE 32: { SEND_COMMAND vdvDEVICE, "'INPUT=2:',ITOA(nCUR_INPUT)" }
                    CASE 33: { SEND_COMMAND vdvDEVICE, "'INPUT=1:',ITOA(nCUR_INPUT)" }
                }
            }
            CASE 34:    // NORMAL ASPECT BUTTON
            CASE 35:    // WIDESCREEN 1 BUTTON
            CASE 36:    // WIDESCREEN 2 BUTTON
            CASE 37:    // WIDESCREEN 3 BUTTON
            CASE 38:    // WIDESCREEN 4 BUTTON
            {
                PULSE[BUTTON.INPUT]
                SWITCH(nBTN - 33)
                {
                    CASE 1: { SEND_COMMAND vdvDEVICE, "'ASPECT=1:',ITOA(nCUR_INPUT)" }
                    CASE 2: { SEND_COMMAND vdvDEVICE, "'ASPECT=2:',ITOA(nCUR_INPUT)" }
                    CASE 3: { SEND_COMMAND vdvDEVICE, "'ASPECT=3:',ITOA(nCUR_INPUT)" }
                    CASE 4: { SEND_COMMAND vdvDEVICE, "'ASPECT=5:',ITOA(nCUR_INPUT)" }
                    CASE 5: { SEND_COMMAND vdvDEVICE, "'ASPECT=6:',ITOA(nCUR_INPUT)" }
                }
            }
            CASE 39:    // RECALL PRESET BUTTON
            CASE 40:    // SAVE PRESET BUTTON
            {
                STACK_VAR INTEGER N
        
                PULSE[BUTTON.INPUT]
                SWITCH(nBTN)
                {
                    CASE 39: { SEND_COMMAND vdvDEVICE, "'RECALL=',ITOA(nPRESET)" }
                    CASE 40: { SEND_COMMAND vdvDEVICE, "'SAVE=',ITOA(nPRESET)" }
                }
                FOR(N = 41; N < 47; N++) { OFF[dvTP, nCHAN_BTN[N]] }
            }
            CASE 41:    // PRESET 1 BUTTON
            CASE 42:    // PRESET 2 BUTTON
            CASE 43:    // PRESET 3 BUTTON
            CASE 44:    // PRESET 4 BUTTON
            CASE 45:    // PRESET 5 BUTTON
            CASE 46:    // PRESET 6 BUTTON
            {
                STACK_VAR INTEGER N
        
                FOR(N = 41; N < 47; N++) { OFF[dvTP, nCHAN_BTN[N]] }
                ON[BUTTON.INPUT]
                nPRESET = nBTN - 40
            }
		  CASE 47:	// DUALVIEW CROP BUTTON
		  CASE 48:	// DUALVIEW NORMAL BUTTON
		  CASE 49:	// DUALVIEW STRETCH BUTTON
		  {
			 PULSE[BUTTON.INPUT]
			 SEND_COMMAND vdvDEVICE, "'DUALVIEW=',ITOA(nBTN - 46)"
		  }
		  CASE 50:	// OUTPUT FADE
		  {
			 SELECT
			 {
				ACTIVE([BUTTON.INPUT] AND cFADE_TIME <> ''): { SEND_COMMAND vdvDEVICE, "'OUTPUT_FADE=0:',cFADE_TIME" }
				ACTIVE(![BUTTON.INPUT] AND cFADE_TIME <> ''):{ SEND_COMMAND vdvDEVICE, "'OUTPUT_FADE=1:',cFADE_TIME" }
				ACTIVE([BUTTON.INPUT] AND cFADE_TIME == ''): { SEND_COMMAND vdvDEVICE, "'OUTPUT_FADE=0'" }
				ACTIVE(![BUTTON.INPUT] AND cFADE_TIME == ''):{ SEND_COMMAND vdvDEVICE, "'OUTPUT_FADE=1'" }
			 }
		  }
		  CASE 51: { SEND_COMMAND vdvDEVICE, "'FULLSCREEN=0'" }	// ALL VIDEO OFF
		  CASE 52:	// OVERSCAN BUTTON
		  {
			 IF ([BUTTON.INPUT]) { SEND_COMMAND vdvDEVICE, "'OVER_SCAN=',ITOA(nCUR_INPUT),':OFF'" }
			 ELSE { SEND_COMMAND vdvDEVICE, "'OVER_SCAN=',ITOA(nCUR_INPUT),':ON'" }
		  }
		  CASE 53:	// UNDERSCAN BUTTON
		  {
			 IF ([BUTTON.INPUT]) { SEND_COMMAND vdvDEVICE, "'UNDER_SCAN=',ITOA(nCUR_INPUT),':OFF'" }
			 ELSE { SEND_COMMAND vdvDEVICE, "'UNDER_SCAN=',ITOA(nCUR_INPUT),':ON'" }
		  }
		  CASE 54:	// BORDER COLOR
		  {
			 IF ([BUTTON.INPUT])
			 {
				OFF[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], ''"
			 }
			 ELSE IF (![BUTTON.INPUT])
			 {
				ON[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cBORDER_COLOR[1]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cBORDER_COLOR[2]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cBORDER_COLOR[3]"
			 }
		  }
 		  CASE 55:	// LABEL BACKGROUND COLOR
		  {
			 IF ([BUTTON.INPUT])
			 {
				OFF[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], ''"
			 }
			 ELSE IF (![BUTTON.INPUT])
			 {
				ON[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cLABEL_BK[1]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cLABEL_BK[2]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cLABEL_BK[3]"
			 }
		  }
		  CASE 56:	// LABEL COLOR
		  {
			 IF ([BUTTON.INPUT])
			 {
				OFF[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], ''"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], ''"
			 }
			 ELSE IF (![BUTTON.INPUT])
			 {
				ON[BUTTON.INPUT]
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[16], cLABEL_COLOR[1]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[17], cLABEL_COLOR[2]"
				SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[18], cLABEL_COLOR[3]"
			 }
		  }
		  CASE 57:	// RED
		  {
			 ON[BUTTON.INPUT]
			 cCOLOR[1] = ''
		  }
		  CASE 58:	// GREEN
		  {
			 ON[BUTTON.INPUT]
			 cCOLOR[2] = ''
		  }
		  CASE 59:	// BLUE
		  {
			 ON[BUTTON.INPUT]
			 cCOLOR[3] = ''
		  }
		  CASE 60:	// COLOR SUBMIT BUTTON
		  {
			 IF ([dvTP, nCHAN_BTN[54]])
			 {
				IF (cCOLOR[1] == '') { cCOLOR[1] = cBORDER_COLOR[1] }
				IF (cCOLOR[2] == '') { cCOLOR[2] = cBORDER_COLOR[2] }
				IF (cCOLOR[3] == '') { cCOLOR[3] = cBORDER_COLOR[3] }
				OFF[dvTP, nCHAN_BTN[54]]
				SEND_COMMAND vdvDEVICE, "'BORDER_COLOR=',ITOA(nCUR_INPUT),':',cCOLOR[1],':',cCOLOR[2],':',cCOLOR[3]"
			 }
			 ELSE IF ([dvTP, nCHAN_BTN[55]])
			 {
				IF (cCOLOR[1] == '') { cCOLOR[1] = cLABEL_BK[1] }
				IF (cCOLOR[2] == '') { cCOLOR[2] = cLABEL_BK[2] }
				IF (cCOLOR[3] == '') { cCOLOR[3] = cLABEL_BK[3] }
				OFF[dvTP, nCHAN_BTN[55]]
				SEND_COMMAND vdvDEVICE, "'LABEL_BGCOLOR=',ITOA(nCUR_INPUT),':',cCOLOR[1],':',cCOLOR[2],':',cCOLOR[3]"
			 }
			 ELSE IF ([dvTP, nCHAN_BTN[56]])
			 {
				IF (cCOLOR[1] == '') { cCOLOR[1] = cLABEL_COLOR[1] }
				IF (cCOLOR[2] == '') { cCOLOR[2] = cLABEL_COLOR[2] }
				IF (cCOLOR[3] == '') { cCOLOR[3] = cLABEL_COLOR[3] }
				OFF[dvTP, nCHAN_BTN[56]]
				SEND_COMMAND vdvDEVICE, "'LABEL_COLOR=',ITOA(nCUR_INPUT),':',cCOLOR[1],':',cCOLOR[2],':',cCOLOR[3]"
			 }
			 cCOLOR[1] = ''
			 cCOLOR[2] = ''
			 cCOLOR[3] = ''
		  }
		  CASE 61:	// BORDER PIXEL WIDTH
		  {
			 ON[BUTTON.INPUT]
			 cBORDER_WIDTH = ''
			 SEND_COMMAND dvTP, "'@TXT', nTXT_BTN[19], cBORDER_WIDTH"
		  }
		  CASE 62:	// LABEL ENABLE TOGGLE
		  {
			 IF ([BUTTON.INPUT]) { SEND_COMMAND vdvDEVICE, "'LABEL_ENABLE=',ITOA(nCUR_INPUT),':0'" }
			 ELSE { SEND_COMMAND vdvDEVICE, "'LABEL_ENABLE=',ITOA(nCUR_INPUT),':1'" }
		  }
		  CASE 63:	// RESTORE IMAGE DEFAULTS
		  {
			 IF (nDEVICE_SCALE)
			 {
				SEND_COMMAND vdvDEVICE, "'BRIGHTNESS=0:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'CONTRAST=100:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'COLOR=100:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'HUE=0:',ITOA(nCUR_INPUT)"
			 }
			 ELSE
			 {
				SEND_COMMAND vdvDEVICE, "'BRIGHTNESS=50:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'CONTRAST=50:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'COLOR=50:',ITOA(nCUR_INPUT)"
				SEND_COMMAND vdvDEVICE, "'HUE=50:',ITOA(nCUR_INPUT)"				
			 }
		  }
        }// END SWITCH(nBTN)
    }// END PUSH
    HOLD[2, REPEAT]:
    {
        STACK_VAR INTEGER nBTN
        
        nBTN = GET_LAST(nCHAN_BTN)
        SWITCH(nBTN)
        {
            CASE 19:    // UP BUTTON
            CASE 20:    // DOWN BUTTON
            CASE 21:    // LEFT BUTTON
            CASE 22:    // RIGHT BUTTON
            {
                SELECT
                {
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':5'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 19): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':1'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 20): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':7'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':<'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 21): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':-'" }
                    ACTIVE([dvTP, nCHAN_BTN[15]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'PANTILT=',ITOA(nCUR_INPUT),':3'" }
                    ACTIVE([dvTP, nCHAN_BTN[16]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'ZOOM=',ITOA(nCUR_INPUT),':+'" }
                    ACTIVE([dvTP, nCHAN_BTN[17]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'MOVE=',ITOA(nCUR_INPUT),':>'" }
                    ACTIVE([dvTP, nCHAN_BTN[18]] AND nBTN == 22): { SEND_COMMAND vdvDEVICE, "'SIZE=',ITOA(nCUR_INPUT),':+'" }
                }// END SELECT
            }
        }// END SWITCH(nBTN)
    }// END HOLD
}// END BUTTON_EVENT[dvTP, nCHAN_BTN]
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

[dvTP, nCHAN_BTN[2]] = (nFREEZE)          // FREEZE STATE
[dvTP, nCHAN_BTN[3]] = (nVIDEO)           // WINDOW STATE

[dvTP, nCHAN_BTN[23]] = (nTEST_PATTERN == 0)   // TEST PATTERN OFF
[dvTP, nCHAN_BTN[24]] = (nTEST_PATTERN == 1)   // BARS
[dvTP, nCHAN_BTN[25]] = (nTEST_PATTERN == 2)   // HORIZONTAL BARS
[dvTP, nCHAN_BTN[26]] = (nTEST_PATTERN == 3)   // GRID

[dvTP, nCHAN_BTN[30]] = (nCUR_TYPE == 4)   // COMPOSITE 1 INPUT TYPE
[dvTP, nCHAN_BTN[31]] = (nCUR_TYPE == 6)   // COMPOSITE 2 INPUT TYPE
[dvTP, nCHAN_BTN[32]] = (nCUR_TYPE == 2)   // S-VIDEO INPUT TYPE
[dvTP, nCHAN_BTN[33]] = (nCUR_TYPE == 1)   // RGB INPUT TYPE

[dvTP, nCHAN_BTN[34]] = (nASPECT == 1)     // NORMAL ASPECT
[dvTP, nCHAN_BTN[35]] = (nASPECT == 2)     // WIDESCREEN 1 ASPECT
[dvTP, nCHAN_BTN[36]] = (nASPECT == 3)     // WIDESCREEN 2 ASPECT
[dvTP, nCHAN_BTN[37]] = (nASPECT == 5)     // WIDESCREEN 3 ASPECT
[dvTP, nCHAN_BTN[38]] = (nASPECT == 6)     // WIDESCREEN 4 ASPECT

[dvTP, nCHAN_BTN[47]] = (nDUALVIEW == 1)	// CROP
[dvTP, nCHAN_BTN[48]] = (nDUALVIEW == 2)	// NORMAL
[dvTP, nCHAN_BTN[49]] = (nDUALVIEW == 3)	// STRETCH

[dvTP, nCHAN_BTN[50]] = nFADE				// OUTPUT FADE TOGGLE

[dvTP, nCHAN_BTN[62]] = bLABEL			// LABEL ENABLE TOGGLE
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)